
//


//Include windows.h and qprowin.h !!
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "qprowin.h"

//=========================================================================
//  MAIN FUNCTION CODE
//=========================================================================
double PowArray(double a){
QProPureAllocReturnArray(2,0);           // you must allocate the array
QProPureReturnNumber(0,0,a);
QProPureReturnNumber(1,0,a*a);
QProPureReturnNumber(2,0,a*a*a);
return 999;                              // simply to bypass compiler warning
}

//===========================================================================
//  QPW prescribed header (and other overhead)
//===========================================================================
SelfDefStructure MyFuncs[] = {
  {
	"double PURE array PowArray(double)",     // Function Prototype
	(FarProc)&PowArray,              // pointer to _exported function
   "Help",                         // Help Line  (optional/samples use default of Help)
	"PowArray"                      // English form of name (match the function name above)
  },
  NULL                              // Always null terminate the list!
};

//=========================================================================
//  QPWMessage = (version 1.0 of toolkit used DLLFunctionDirectory)
//  This function serves as the main initialization and registration
//  entrypoint for QPW add-ins.  The return value of this function is a
//  pointer to a table which holds all of the function prototyping info
//=========================================================================
//  #pragma argsused is a command to disable var checking in this function
#pragma argsused

BOOL Exported QPWMessage(QPWMsg msg, WORD wParam, DWORD lParam)
{
    LPDLLInfo pDLL = (LPDLLInfo)lParam;

    switch (msg) {
	case QPWMSG_Init:
	case QPWMSG_Term:
	    break;
	case QPWMSG_Info:
	    pDLL->wVersion = QProInterfaceVersion;
	    pDLL->wSDSSize = sizeof(SelfDefStructure);
	    pDLL->pSDS = &MyFuncs[0];
	    return TRUE;
    }
    return FALSE;
}


//=========================================================================
//      WINDOWS REQUIRED STUFF (LibMain and WEP)
//=========================================================================

//=========================================================================
//  LibMain   ( Windows prescribed DLL entrypoint )
//=========================================================================
//  #pragma argsused is a command to disable var checking in this function
#pragma argsused
int FAR PASCAL LibMain( HANDLE hInstance, WORD wDataSeg,
			WORD cbHeapSize, LPSTR lpszCmdLine)
{
//  perform DLL initialization
	if (cbHeapSize != 0) {
		UnlockData(0);;
	}
    return 1;
}

//=========================================================================
//  WEP  ( Windows specified de-initialization entrypoint for this DLL )
//=========================================================================
//  #pragma argsused is a command to disable var checking in this function
#pragma argsused
int FAR _export PASCAL WEP(int nParameter)
{
    return 1;
}
